package exe.model;
import java.util.Hashtable;

public class Rack {
	
	private String name;
	private int powerCapacity;
	private Hashtable<String, Component> comps = new Hashtable<String, Component>();
	private int powerReqSum = 0;
	
	public Rack(String name, int powerCapacity)
	{
		this.name = name;
		this.powerCapacity = powerCapacity;
	}
	public void addComponent(Component comp) throws CapacityExceeded
	{
		String name = comp.getName();
		if ( (powerReqSum + comp.getPowerReq()) <= this.powerCapacity )
		{
			powerReqSum += comp.getPowerReq();
			comps.put(name, comp);
			comp.setRack( this );
		}
		else
		{
			int exceededBy = powerReqSum + comp.getPowerReq() - powerCapacity;
			throw new CapacityExceeded("While trying to add comp " + name +
									   ", the capacity was exceeded by " + exceededBy);
		}
	}
	public void removeComponent(String name)
	{
		if (name != null)
		{
			if (comps.containsKey(name))
			{
				Component comp = (Component)comps.get(name);
				powerReqSum -= comp.getPowerReq();
				comps.remove(name);
			}
		}
	}
	
	public Component getComponent( String name )
	{
		Component result = null;
		if( comps.containsKey(name))
		{
			result = comps.get(name);
		}
		return result;
	}
	
	public int getPowerReqSum()
	{
		return powerReqSum;
	}
	public String getName(){return name;}
}
